Subject: Re: linux-next: build warning after merge of the landlock tree

From: Mickaël Salaün <[email-masked]>
Date: Wed, 4 Oct 2023 13:02:15 +0200

On Tue, Oct 03, 2023 at 03:40:23PM +0200, Arnd Bergmann wrote:
> On Tue, Oct 3, 2023, at 15:15, Mickaël Salaün wrote:
> > PowerPC-64 follows the LP64 data model and then uses int-l64.h (instead of
> > int-ll64.h like most architectures) for user space code.
> >
> > Here is the same code with the (suggested) "%lu" token on x86_86:
> >
> >   samples/landlock/sandboxer.c: In function ‘populate_ruleset_net’:
> >   samples/landlock/sandboxer.c:170:77: error: format ‘%lu’ expects 
> > argument of type ‘long unsigned int’, but argument 3 has type ‘__u64’ 
> > {aka ‘long long unsigned int’} [-Werror=format=]
> >     170 |                                 "Failed to update the ruleset 
> > with port \"%lu\": %s\n",
> >         |                                                               
> >             ~~^
> >         |                                                               
> >               |
> >         |                                                               
> >               long unsigned int
> >         |                                                               
> >             %llu
> >     171 |                                 net_port.port, 
> > strerror(errno));
> >         |                                 ~~~~~~~~~~~~~
> >         |                                         |
> >         |                                         __u64 {aka long long 
> > unsigned int}
> >
> >
> > We would then need to cast __u64 to unsigned long long to avoid this warning,
> > which may look useless, of even buggy, for people taking a look at this sample.
> >
> > Anyway, it makes more sense to cast it to __u16 because it is the
> > expected type for a TCP port. I'm updating the patch with that.
> > Konstantin, please take this fix for the next series:
> > https://git.kernel.org/mic/c/fc9de206a61a
> >
> >
> > On Tue, Oct 03, 2023 at 02:27:37PM +1100, Stephen Rothwell wrote:
> >> Hi all,
> >> 
> >> After merging the landlock tree, today's linux-next build (powerpc
> >> allyesconfig) produced this warning:
> >> 
> >> samples/landlock/sandboxer.c: In function 'populate_ruleset_net':
> >> samples/landlock/sandboxer.c:170:78: warning: format '%llu' expects argument of type 'long long unsigned int', but argument 3 has type '__u64' {aka 'long unsigned int'} [-Wformat=]
> >>   170 |                                 "Failed to update the ruleset with port \"%llu\": %s\n"
> 
> I think defining the __SANE_USERSPACE_TYPES__ macro should take care of this,
> then __u64 has the same type as it does in the kernel.

Thanks! I didn't know about this macro. We'll use that and print the
full 64-bit value.

>         Arnd